commit f6da27eb1cbb9a6bbcfe2a6e39f99cb1cb372704
Author: Jonathan Wakely <accu@kayari.org>
Date:   Tue Apr 15 18:48:13 2014 +0100

    	* testsuite/ext/random/*: Fix incorrect standard references in
    	comments.

diff --git a/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/cons/default.cc b/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/cons/default.cc
index c1b3f56..a6dbd33 100644
--- a/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/cons/default.cc
+++ b/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/cons/default.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template hypergeometric_distribution [rand.dist.ext.hypergeometric]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template hypergeometric_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/cons/parms.cc b/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/cons/parms.cc
index 0f541d0..8d98ab8 100644
--- a/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/cons/parms.cc
+++ b/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/cons/parms.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template hypergeometric_distribution [rand.dist.ext.hypergeometric]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template hypergeometric_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/operators/equal.cc b/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/operators/equal.cc
index daf4a75..7f20ef6 100644
--- a/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/operators/equal.cc
+++ b/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/operators/equal.cc
@@ -20,7 +20,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.5.8.4.5 Class template rice_distribution [rand.dist.ext.hypergeometric]
+// Class template hypergeometric_distribution
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/operators/inequal.cc b/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/operators/inequal.cc
index c4d3c8c..4f20232 100644
--- a/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/operators/inequal.cc
+++ b/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/operators/inequal.cc
@@ -20,7 +20,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.5.8.4.5 Class template rice_distribution [rand.dist.ext.hypergeometric]
+// Class template hypergeometric_distribution
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/operators/serialize.cc b/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/operators/serialize.cc
index bd2d579..b9958c9 100644
--- a/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/operators/serialize.cc
+++ b/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/operators/serialize.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template hypergeometric_distribution [rand.dist.ext.hypergeometric]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template hypergeometric_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <sstream>
diff --git a/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/operators/values.cc b/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/operators/values.cc
index ceaaf38..f730ec1 100644
--- a/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/operators/values.cc
+++ b/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/operators/values.cc
@@ -21,9 +21,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template hypergeometric_distribution
-// [rand.dist.ext.hypergeometric]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template hypergeometric_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <functional>
diff --git a/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/requirements/typedefs.cc b/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/requirements/typedefs.cc
index 1263fde..1b5707e 100644
--- a/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/requirements/typedefs.cc
+++ b/libstdc++-v3/testsuite/ext/random/hypergeometric_distribution/requirements/typedefs.cc
@@ -21,8 +21,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template hypergeometric_distribution [rand.dist.ext.hypergeometric]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template hypergeometric_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 
diff --git a/libstdc++-v3/testsuite/ext/random/k_distribution/cons/default.cc b/libstdc++-v3/testsuite/ext/random/k_distribution/cons/default.cc
index b0c53f8..290423c 100644
--- a/libstdc++-v3/testsuite/ext/random/k_distribution/cons/default.cc
+++ b/libstdc++-v3/testsuite/ext/random/k_distribution/cons/default.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template k_distribution [rand.dist.ext.k]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template k_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/k_distribution/cons/parms.cc b/libstdc++-v3/testsuite/ext/random/k_distribution/cons/parms.cc
index 0f1ae6f..a72f9bc 100644
--- a/libstdc++-v3/testsuite/ext/random/k_distribution/cons/parms.cc
+++ b/libstdc++-v3/testsuite/ext/random/k_distribution/cons/parms.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template k_distribution [rand.dist.ext.k]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template k_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/k_distribution/operators/equal.cc b/libstdc++-v3/testsuite/ext/random/k_distribution/operators/equal.cc
index 576322c..0c88a1c 100644
--- a/libstdc++-v3/testsuite/ext/random/k_distribution/operators/equal.cc
+++ b/libstdc++-v3/testsuite/ext/random/k_distribution/operators/equal.cc
@@ -20,7 +20,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.5.8.4.5 Class template k_distribution [rand.dist.ext.k]
+// Class template k_distribution
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/k_distribution/operators/inequal.cc b/libstdc++-v3/testsuite/ext/random/k_distribution/operators/inequal.cc
index d24a5e0..c625e5a 100644
--- a/libstdc++-v3/testsuite/ext/random/k_distribution/operators/inequal.cc
+++ b/libstdc++-v3/testsuite/ext/random/k_distribution/operators/inequal.cc
@@ -20,7 +20,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.5.8.4.5 Class template k_distribution [rand.dist.ext.k]
+// Class template k_distribution
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/k_distribution/operators/serialize.cc b/libstdc++-v3/testsuite/ext/random/k_distribution/operators/serialize.cc
index e4350a5..04faec1 100644
--- a/libstdc++-v3/testsuite/ext/random/k_distribution/operators/serialize.cc
+++ b/libstdc++-v3/testsuite/ext/random/k_distribution/operators/serialize.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template k_distribution [rand.dist.ext.k]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template k_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <sstream>
diff --git a/libstdc++-v3/testsuite/ext/random/k_distribution/requirements/typedefs.cc b/libstdc++-v3/testsuite/ext/random/k_distribution/requirements/typedefs.cc
index 5c5948b..3cca9ab 100644
--- a/libstdc++-v3/testsuite/ext/random/k_distribution/requirements/typedefs.cc
+++ b/libstdc++-v3/testsuite/ext/random/k_distribution/requirements/typedefs.cc
@@ -21,8 +21,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template k_distribution [rand.dist.ext.k]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template k_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 
diff --git a/libstdc++-v3/testsuite/ext/random/logistic_distribution/cons/default.cc b/libstdc++-v3/testsuite/ext/random/logistic_distribution/cons/default.cc
index 3b4c943..4ca678a 100644
--- a/libstdc++-v3/testsuite/ext/random/logistic_distribution/cons/default.cc
+++ b/libstdc++-v3/testsuite/ext/random/logistic_distribution/cons/default.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template logistic_distribution [rand.dist.ext.logistic]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template logistic_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/logistic_distribution/cons/parms.cc b/libstdc++-v3/testsuite/ext/random/logistic_distribution/cons/parms.cc
index fed74f8..f77e1bc 100644
--- a/libstdc++-v3/testsuite/ext/random/logistic_distribution/cons/parms.cc
+++ b/libstdc++-v3/testsuite/ext/random/logistic_distribution/cons/parms.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template logistic_distribution [rand.dist.ext.logistic]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template logistic_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/logistic_distribution/operators/equal.cc b/libstdc++-v3/testsuite/ext/random/logistic_distribution/operators/equal.cc
index 4f85192..8ad5a13 100644
--- a/libstdc++-v3/testsuite/ext/random/logistic_distribution/operators/equal.cc
+++ b/libstdc++-v3/testsuite/ext/random/logistic_distribution/operators/equal.cc
@@ -20,7 +20,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.5.8.4.5 Class template logistic_distribution [rand.dist.ext.logistic]
+// Class template logistic_distribution
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/logistic_distribution/operators/inequal.cc b/libstdc++-v3/testsuite/ext/random/logistic_distribution/operators/inequal.cc
index 6d9ff42..7654bc3 100644
--- a/libstdc++-v3/testsuite/ext/random/logistic_distribution/operators/inequal.cc
+++ b/libstdc++-v3/testsuite/ext/random/logistic_distribution/operators/inequal.cc
@@ -20,7 +20,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.5.8.4.5 Class template logistic_distribution [rand.dist.ext.logistic]
+// Class template logistic_distribution
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/logistic_distribution/operators/serialize.cc b/libstdc++-v3/testsuite/ext/random/logistic_distribution/operators/serialize.cc
index df071ee..84902db 100644
--- a/libstdc++-v3/testsuite/ext/random/logistic_distribution/operators/serialize.cc
+++ b/libstdc++-v3/testsuite/ext/random/logistic_distribution/operators/serialize.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template logistic_distribution [rand.dist.ext.logistic]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template logistic_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <sstream>
diff --git a/libstdc++-v3/testsuite/ext/random/logistic_distribution/requirements/typedefs.cc b/libstdc++-v3/testsuite/ext/random/logistic_distribution/requirements/typedefs.cc
index ff018cf..631a0da 100644
--- a/libstdc++-v3/testsuite/ext/random/logistic_distribution/requirements/typedefs.cc
+++ b/libstdc++-v3/testsuite/ext/random/logistic_distribution/requirements/typedefs.cc
@@ -21,8 +21,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template logistic_distribution [rand.dist.ext.logistic]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template logistic_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 
diff --git a/libstdc++-v3/testsuite/ext/random/nakagami_distribution/cons/default.cc b/libstdc++-v3/testsuite/ext/random/nakagami_distribution/cons/default.cc
index 1b6c3421..185b14a 100644
--- a/libstdc++-v3/testsuite/ext/random/nakagami_distribution/cons/default.cc
+++ b/libstdc++-v3/testsuite/ext/random/nakagami_distribution/cons/default.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template nakagami_distribution [rand.dist.ext.nakagami]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template nakagami_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/nakagami_distribution/cons/parms.cc b/libstdc++-v3/testsuite/ext/random/nakagami_distribution/cons/parms.cc
index 25a7c9c..95c5b12 100644
--- a/libstdc++-v3/testsuite/ext/random/nakagami_distribution/cons/parms.cc
+++ b/libstdc++-v3/testsuite/ext/random/nakagami_distribution/cons/parms.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template nakagami_distribution [rand.dist.ext.nakagami]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template nakagami_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/nakagami_distribution/operators/equal.cc b/libstdc++-v3/testsuite/ext/random/nakagami_distribution/operators/equal.cc
index 058373a..f45b8a7 100644
--- a/libstdc++-v3/testsuite/ext/random/nakagami_distribution/operators/equal.cc
+++ b/libstdc++-v3/testsuite/ext/random/nakagami_distribution/operators/equal.cc
@@ -20,7 +20,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.5.8.4.5 Class template nakagami_distribution [rand.dist.ext.nakagami]
+// Class template nakagami_distribution
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/nakagami_distribution/operators/inequal.cc b/libstdc++-v3/testsuite/ext/random/nakagami_distribution/operators/inequal.cc
index 2a7c308..4f0315e 100644
--- a/libstdc++-v3/testsuite/ext/random/nakagami_distribution/operators/inequal.cc
+++ b/libstdc++-v3/testsuite/ext/random/nakagami_distribution/operators/inequal.cc
@@ -20,7 +20,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.5.8.4.5 Class template nakagami_distribution [rand.dist.ext.nakagami]
+// Class template nakagami_distribution
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/nakagami_distribution/operators/serialize.cc b/libstdc++-v3/testsuite/ext/random/nakagami_distribution/operators/serialize.cc
index fb7cc28..eedfd84 100644
--- a/libstdc++-v3/testsuite/ext/random/nakagami_distribution/operators/serialize.cc
+++ b/libstdc++-v3/testsuite/ext/random/nakagami_distribution/operators/serialize.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template nakagami_distribution [rand.dist.ext.nakagami]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template nakagami_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <sstream>
diff --git a/libstdc++-v3/testsuite/ext/random/nakagami_distribution/requirements/typedefs.cc b/libstdc++-v3/testsuite/ext/random/nakagami_distribution/requirements/typedefs.cc
index 9718039..e51d622 100644
--- a/libstdc++-v3/testsuite/ext/random/nakagami_distribution/requirements/typedefs.cc
+++ b/libstdc++-v3/testsuite/ext/random/nakagami_distribution/requirements/typedefs.cc
@@ -21,8 +21,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template nakagami_distribution [rand.dist.ext.nakagami]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template nakagami_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 
diff --git a/libstdc++-v3/testsuite/ext/random/pareto_distribution/cons/default.cc b/libstdc++-v3/testsuite/ext/random/pareto_distribution/cons/default.cc
index 0bc4e42..6a5b68f 100644
--- a/libstdc++-v3/testsuite/ext/random/pareto_distribution/cons/default.cc
+++ b/libstdc++-v3/testsuite/ext/random/pareto_distribution/cons/default.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template pareto_distribution [rand.dist.ext.pareto]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template pareto_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/pareto_distribution/cons/parms.cc b/libstdc++-v3/testsuite/ext/random/pareto_distribution/cons/parms.cc
index c8cccc4..93f4819 100644
--- a/libstdc++-v3/testsuite/ext/random/pareto_distribution/cons/parms.cc
+++ b/libstdc++-v3/testsuite/ext/random/pareto_distribution/cons/parms.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template pareto_distribution [rand.dist.ext.pareto]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template pareto_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/pareto_distribution/operators/equal.cc b/libstdc++-v3/testsuite/ext/random/pareto_distribution/operators/equal.cc
index 380820e..7daf67b 100644
--- a/libstdc++-v3/testsuite/ext/random/pareto_distribution/operators/equal.cc
+++ b/libstdc++-v3/testsuite/ext/random/pareto_distribution/operators/equal.cc
@@ -20,7 +20,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.5.8.4.5 Class template pareto_distribution [rand.dist.ext.pareto]
+// Class template pareto_distribution
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/pareto_distribution/operators/inequal.cc b/libstdc++-v3/testsuite/ext/random/pareto_distribution/operators/inequal.cc
index db18b1a..e3c73ae 100644
--- a/libstdc++-v3/testsuite/ext/random/pareto_distribution/operators/inequal.cc
+++ b/libstdc++-v3/testsuite/ext/random/pareto_distribution/operators/inequal.cc
@@ -20,7 +20,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.5.8.4.5 Class template pareto_distribution [rand.dist.ext.pareto]
+// Class template pareto_distribution
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/pareto_distribution/operators/serialize.cc b/libstdc++-v3/testsuite/ext/random/pareto_distribution/operators/serialize.cc
index c64f920..ed032a1 100644
--- a/libstdc++-v3/testsuite/ext/random/pareto_distribution/operators/serialize.cc
+++ b/libstdc++-v3/testsuite/ext/random/pareto_distribution/operators/serialize.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template pareto_distribution [rand.dist.ext.pareto]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template pareto_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <sstream>
diff --git a/libstdc++-v3/testsuite/ext/random/pareto_distribution/requirements/typedefs.cc b/libstdc++-v3/testsuite/ext/random/pareto_distribution/requirements/typedefs.cc
index d21917d..08ff72e 100644
--- a/libstdc++-v3/testsuite/ext/random/pareto_distribution/requirements/typedefs.cc
+++ b/libstdc++-v3/testsuite/ext/random/pareto_distribution/requirements/typedefs.cc
@@ -21,8 +21,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template pareto_distribution [rand.dist.ext.pareto]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template pareto_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 
diff --git a/libstdc++-v3/testsuite/ext/random/rice_distribution/cons/default.cc b/libstdc++-v3/testsuite/ext/random/rice_distribution/cons/default.cc
index 44907df..5b29710 100644
--- a/libstdc++-v3/testsuite/ext/random/rice_distribution/cons/default.cc
+++ b/libstdc++-v3/testsuite/ext/random/rice_distribution/cons/default.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template rice_distribution [rand.dist.ext.rice]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template rice_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/rice_distribution/cons/parms.cc b/libstdc++-v3/testsuite/ext/random/rice_distribution/cons/parms.cc
index cac284f..7ba775f 100644
--- a/libstdc++-v3/testsuite/ext/random/rice_distribution/cons/parms.cc
+++ b/libstdc++-v3/testsuite/ext/random/rice_distribution/cons/parms.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template rice_distribution [rand.dist.ext.rice]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template rice_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/rice_distribution/operators/equal.cc b/libstdc++-v3/testsuite/ext/random/rice_distribution/operators/equal.cc
index 896dd0f..ab38de1 100644
--- a/libstdc++-v3/testsuite/ext/random/rice_distribution/operators/equal.cc
+++ b/libstdc++-v3/testsuite/ext/random/rice_distribution/operators/equal.cc
@@ -20,7 +20,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.5.8.4.5 Class template rice_distribution [rand.dist.ext.rice]
+// Class template rice_distribution
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/rice_distribution/operators/inequal.cc b/libstdc++-v3/testsuite/ext/random/rice_distribution/operators/inequal.cc
index 8c9bea3..3b9b430 100644
--- a/libstdc++-v3/testsuite/ext/random/rice_distribution/operators/inequal.cc
+++ b/libstdc++-v3/testsuite/ext/random/rice_distribution/operators/inequal.cc
@@ -20,7 +20,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.5.8.4.5 Class template rice_distribution [rand.dist.ext.rice]
+// Class template rice_distribution
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/rice_distribution/operators/serialize.cc b/libstdc++-v3/testsuite/ext/random/rice_distribution/operators/serialize.cc
index 2f7dea3..3a3c7af 100644
--- a/libstdc++-v3/testsuite/ext/random/rice_distribution/operators/serialize.cc
+++ b/libstdc++-v3/testsuite/ext/random/rice_distribution/operators/serialize.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template rice_distribution [rand.dist.ext.rice]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template rice_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <sstream>
diff --git a/libstdc++-v3/testsuite/ext/random/rice_distribution/requirements/typedefs.cc b/libstdc++-v3/testsuite/ext/random/rice_distribution/requirements/typedefs.cc
index ab08583..d2351f8 100644
--- a/libstdc++-v3/testsuite/ext/random/rice_distribution/requirements/typedefs.cc
+++ b/libstdc++-v3/testsuite/ext/random/rice_distribution/requirements/typedefs.cc
@@ -21,8 +21,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template rice_distribution [rand.dist.ext.rice]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template rice_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 
diff --git a/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/cons/default.cc b/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/cons/default.cc
index fb48fe2..9e3da86 100644
--- a/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/cons/default.cc
+++ b/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/cons/default.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 26.4.8.3.* Class template uniform_in_sphere [rand.dist.ext.uniform_on_sphere]
-// 26.4.2.4 Concept RandomNumberDistribution [rand.concept.dist]
+// Class template uniform_on_sphere
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/operators/equal.cc b/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/operators/equal.cc
index f5b8d17..83f7dd9 100644
--- a/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/operators/equal.cc
+++ b/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/operators/equal.cc
@@ -20,7 +20,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// Class template uniform_on_sphere_distribution [rand.dist.ext.uniform_on_sphere]
+// Class template uniform_on_sphere_distribution
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/operators/generate.cc b/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/operators/generate.cc
index c402444..deccbb2 100644
--- a/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/operators/generate.cc
+++ b/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/operators/generate.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// Class template uniform_on_sphere_distribution [rand.dist.ext.uniform_on_sphere]
-// Concept RandomNumberDistribution [rand.concept.dist]
+// Class template uniform_on_sphere_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <sstream>
diff --git a/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/operators/inequal.cc b/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/operators/inequal.cc
index 2675652..1d30580 100644
--- a/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/operators/inequal.cc
+++ b/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/operators/inequal.cc
@@ -20,7 +20,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// Class template uniform_on_sphere_distribution [rand.dist.ext.uniform_on_sphere]
+// Class template uniform_on_sphere_distribution
 
 #include <ext/random>
 #include <testsuite_hooks.h>
diff --git a/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/operators/serialize.cc b/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/operators/serialize.cc
index e9a758c..ee90a05 100644
--- a/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/operators/serialize.cc
+++ b/libstdc++-v3/testsuite/ext/random/uniform_on_sphere_distribution/operators/serialize.cc
@@ -20,8 +20,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// Class template uniform_on_sphere_distribution [rand.dist.ext.uniform_on_sphere]
-// Concept RandomNumberDistribution [rand.concept.dist]
+// Class template uniform_on_sphere_distribution
+// 26.5.1.6 Random number distribution requirements [rand.req.dist]
 
 #include <ext/random>
 #include <sstream>